diff -rupN seq24-rev48 adding win32/src/seqroll.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqroll.cpp
--- seq24-rev48 adding win32/src/seqroll.cpp	2009-05-20 20:30:47.578125000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqroll.cpp	2009-05-20 20:30:56.328125000 -0500
@@ -1455,3 +1188,919 @@ seqroll::on_scroll_event( GdkEventScroll
 
 }
 
+
+
+
+
+
+
+//////////////////////////
+// interaction methods
+//////////////////////////
+
+
+
+void FruitySeqRollInput::updateMousePtr(seqroll& ths)
+{
+     // context sensitive mouse
+     {
+        long drop_tick;
+        int drop_note;
+        ths.convert_xy( ths.m_current_x, ths.m_current_y, &drop_tick, &drop_note );
+        long start, end, note;
+        if (ths.m_is_drag_pasting || ths.m_selecting || ths.m_moving || ths.m_growing || ths.m_paste)
+        {
+            ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+        }
+        else if (!m_adding &&
+            ths.m_seq->intersectNotes( drop_tick, drop_note, start, end, note ) && note == drop_note)
+	    {
+            long handle_size = clamp( c_handlesize, 0, (end-start)/3 );
+            if (start <= drop_tick && drop_tick <= start + handle_size)
+            {
+               //get_window()->set_cursor( Gdk::Cursor( Gdk::RIGHT_PTR ));
+               ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CENTER_PTR )); // not supported yet
+            }
+            else if (end - handle_size <= drop_tick && drop_tick <= end)
+            {
+               ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+            }
+            else
+            {
+               ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CENTER_PTR ));
+            }
+        }
+        else
+        {
+            ths.get_window()->set_cursor( Gdk::Cursor( Gdk::PENCIL ));
+        }
+    }
+}
+
+
+bool FruitySeqRollInput::on_button_press_event(GdkEventButton* a_ev, seqroll& ths)
+{
+    int numsel;
+
+    long tick_s;
+    long tick_f;
+    int note_h;
+    int note_l;
+
+    int norm_x, norm_y, snapped_x, snapped_y;
+
+    ths.grab_focus(  );
+
+    bool needs_update = false;
+
+    snapped_x = norm_x = (int) (a_ev->x + ths.m_scroll_offset_x );
+    snapped_y = norm_y = (int) (a_ev->y + ths.m_scroll_offset_y );
+
+    ths.snap_x( &snapped_x );
+    ths.snap_y( &snapped_y );
+
+    /* y is always snapped */
+    ths.m_current_y = ths.m_drop_y = snapped_y;
+
+    /* reset box that holds dirty redraw spot */
+    ths.m_old.x = 0;
+    ths.m_old.y = 0;
+    ths.m_old.width = 0;
+    ths.m_old.height = 0;
+
+    // ctrl-v pressed, we're waiting for a click to show where to paste
+    if ( ths.m_paste ){
+
+        ths.convert_xy( snapped_x, snapped_y, &tick_s, &note_h );
+        ths.m_paste = false;
+        ths.m_seq->push_undo();
+        ths.m_seq->paste_selected( tick_s, note_h );
+
+        needs_update = true;
+
+    } else {
+
+        /*  left mouse button     */
+        if ( a_ev->button == 1)
+        {
+
+            /* selection, normal x */
+            ths.m_current_x = ths.m_drop_x = norm_x;
+
+            /* turn x,y in to tick/note */
+            ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &tick_s, &note_h );
+
+            // if not on top of event then add one...
+            if ( m_canadd && ! ths.m_seq->select_note_events( tick_s, note_h,
+                                             tick_s, note_h,
+                                             sequence::e_would_select ) &&
+                 !(a_ev->state & GDK_CONTROL_MASK) )
+            {
+                /* start the paint job */
+                ths.m_painting = true;
+                m_adding = true;
+
+                /* adding, snapped x */
+                ths.m_current_x = ths.m_drop_x = snapped_x;
+                ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &tick_s, &note_h );
+
+                // test if a note is already there
+                // fake select, if so, no add
+                if ( ! ths.m_seq->select_note_events( tick_s, note_h,
+                                                  tick_s, note_h,
+                                                  sequence::e_would_select ))
+                {
+                    /* add note, length = little less than snap */
+                    ths.m_seq->push_undo();
+                    ths.m_seq->add_note( tick_s, ths.m_note_length - 2, note_h, true );
+
+                    needs_update = true;
+                }
+
+            }
+            else /* selecting */
+            {
+                // if the under the cursor is not a selected note...
+                if ( !ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_is_selected ))
+                {
+                    // if clicking a note ...
+                    if (ths.m_seq->select_note_events( tick_s,note_h,tick_s,note_h,
+                                                   sequence::e_would_select ) )
+                    {
+                        // ... unselect all if ctrl not held
+                        if (! (a_ev->state & GDK_CONTROL_MASK))
+                           ths.m_seq->unselect();
+                    }
+                    // if clicking empty space ...
+                    else
+                    {
+                        // ... unselect all if ctrl-shift not held
+                        if (! ((a_ev->state & GDK_CONTROL_MASK) &&
+                               (a_ev->state & GDK_SHIFT_MASK)) )
+                           ths.m_seq->unselect();
+                    }
+
+                    /* on direct click select only one event */
+                    numsel = ths.m_seq->select_note_events( tick_s,note_h,tick_s,note_h,
+                                                        sequence::e_select_one );
+                    // prevent deselect in button_release()
+                    if (numsel)
+                       ths.m_justselected_one = true;
+
+                    // if nothing selected, start the selection box
+                    if (numsel == 0 && (a_ev->state & GDK_CONTROL_MASK))
+                        ths.m_selecting = true;
+
+                    needs_update = true;
+                }
+
+                // if note under cursor is selected
+                if ( ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_is_selected ))
+                {
+                    // context sensitive mouse
+                    bool left_mouse_handle = false;
+                    bool right_mouse_handle = false;
+                    bool center_mouse_handle = false;
+                    {
+                        long drop_tick;
+                        int drop_note;
+                        ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &drop_tick, &drop_note );
+                        long start, end, note;
+                        if (ths.m_seq->intersectNotes( drop_tick, drop_note, start, end, note ) && note == drop_note)
+                	    {
+                            long handle_size = clamp( c_handlesize, 0, (end-start)/3 ); // 16 wide unless very small...
+                            if (start <= drop_tick && drop_tick <= start + handle_size)
+                            {
+                                //left_mouse_handle = true; // not supported yet
+                                center_mouse_handle = true;  
+                            }
+                            else if (end - handle_size <= drop_tick && drop_tick <= end)
+                            {
+                                right_mouse_handle = true;
+                            }
+                            else
+                            {
+                                center_mouse_handle = true;
+                            }
+                        }
+                    }
+
+                    // grab/move the note
+                    if ( center_mouse_handle &&
+                         a_ev->button == 1 && !(a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_moving_init = true;
+                        needs_update = true;
+
+
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note_h,
+                                &tick_f, &note_l );
+
+
+                        ths.convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
+                                &ths.m_selected.x,
+                                &ths.m_selected.y,
+                                &ths.m_selected.width,
+                                &ths.m_selected.height );
+
+                        /* save offset that we get from the snap above */
+                        int adjusted_selected_x = ths.m_selected.x;
+                        ths.snap_x( &adjusted_selected_x );
+                        ths.m_move_snap_offset_x = ( ths.m_selected.x - adjusted_selected_x);
+
+                        /* align selection for drawing */
+                        ths.snap_x( &ths.m_selected.x );
+
+                        ths.m_current_x = ths.m_drop_x = snapped_x;
+                    }
+                    // ctrl left click when stuff is already selected
+                    else if (a_ev->button == 1 && (a_ev->state & GDK_CONTROL_MASK) &&
+                             ths.m_seq->select_note_events( tick_s, note_h,
+                                                        tick_s, note_h,
+                                                        sequence::e_is_selected ))
+                    {
+                        ths.m_is_drag_pasting_start = true;
+                        m_drag_paste_start_pos[0] = (long)a_ev->x;
+                        m_drag_paste_start_pos[1] = (long)a_ev->y;
+                        //printf( "start: %lf  %lf\n", a_ev->x, a_ev->y );
+                    }
+
+                    /* left click on the right handle - grow/resize event  */
+                    if ( (right_mouse_handle &&
+                          a_ev->button == 1 && ! (a_ev->state & GDK_CONTROL_MASK)) ||
+                          a_ev->button == 2 ){
+                        ths.m_growing = true;
+
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note_h,
+                                    &tick_f, &note_l );
+
+                        ths.convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
+                                &ths.m_selected.x,
+                                &ths.m_selected.y,
+                                &ths.m_selected.width,
+                                &ths.m_selected.height );
+                    }
+                }
+           }
+       }
+
+
+        /*     right click      */
+        if ( a_ev->button == 3 ){
+            /* selection, normal x */
+            ths.m_current_x = ths.m_drop_x = norm_x;
+
+            /* turn x,y in to tick/note */
+            ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &tick_s, &note_h );
+
+
+            // erase event(s) under cursor if there is one
+            if ( ths.m_seq->select_note_events( tick_s, note_h,
+                                            tick_s, note_h,
+                                            sequence::e_would_select) )
+            {
+                /* right ctrl click: remove all selected notes */
+                if (a_ev->state & GDK_CONTROL_MASK)
+                {
+                    ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_select_one );
+                    ths.m_seq->push_undo();
+                    ths.m_seq->mark_selected();
+                    ths.m_seq->remove_marked();
+                }
+                /* right click: remove only the note under the cursor,
+                   leave the selection intact */
+                else
+                {
+                    ths.m_seq->push_undo();
+                    ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_remove_one );
+                }
+
+                // hold down the right button, drag mouse around erasing notes:
+                m_erase_painting = true;
+
+                // repaint... we've changed the notes.
+                needs_update = true;
+            }
+            else /* selecting */
+            {
+
+                if  ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    ths.m_seq->unselect();
+
+                // nothing selected, start the selection box
+                ths.m_selecting = true;
+
+                needs_update = true;
+            }
+        }
+    }
+
+    // context sensative mouse pointer...
+    updateMousePtr( ths );
+
+    /* if they clicked, something changed */
+    if ( needs_update ){
+        ////printf( "needs update\n" );
+        ths.m_seq->set_dirty();
+        //redraw_events();
+    }
+    return true;
+}
+
+bool FruitySeqRollInput::on_button_release_event(GdkEventButton* a_ev, seqroll& ths)
+{
+    long tick_s;
+    long tick_f;
+    int note_h;
+    int note_l;
+    int x,y,w,h;
+    int numsel;
+
+    bool needs_update = false;
+
+    ths.m_current_x = (int) (a_ev->x + ths.m_scroll_offset_x );
+    ths.m_current_y = (int) (a_ev->y + ths.m_scroll_offset_y );
+
+    ths.snap_y( &ths.m_current_y );
+
+    if ( ths.m_moving || ths.m_is_drag_pasting )
+        ths.snap_x( &ths.m_current_x );
+
+    int delta_x = ths.m_current_x - ths.m_drop_x;
+    int delta_y = ths.m_current_y - ths.m_drop_y;
+
+    long delta_tick;
+    int delta_note;
+
+    // middle click, or ctrlleft click button up
+    if ( a_ev->button == 1 ||
+         a_ev->button == 2 ){
+        if ( ths.m_growing )
+        {
+            /* convert deltas into screen corridinates */
+            ths.convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
+            ths.m_seq->push_undo();
+
+            if ( a_ev->state & GDK_SHIFT_MASK )
+                ths.m_seq->stretch_selected( delta_tick );
+            else
+                ths.m_seq->grow_selected( delta_tick );
+
+            needs_update = true;
+        }
+    }
+    long int current_tick;
+    int current_note;
+    ths.convert_xy( ths.m_current_x, ths.m_current_y, &current_tick, &current_note );
+
+
+    // ctrl-left click button up for select/drag copy/paste
+    // left click button up for ending a move of selected notes
+    if ( a_ev->button == 1 ){
+        m_adding = false;
+        if ( ths.m_is_drag_pasting )
+        {
+            ths.m_is_drag_pasting = false;
+            ths.m_is_drag_pasting_start = false;
+
+            /* convert deltas into screen corridinates */
+            ths.m_paste = false;
+            ths.m_seq->push_undo();
+            ths.m_seq->paste_selected( current_tick, current_note );
+
+            needs_update = true;
+
+            //m_seq->unselect();
+        }
+        // ctrl-left click but without movement - select a note
+        if (ths.m_is_drag_pasting_start)
+        {
+            ths.m_is_drag_pasting_start = false;
+
+            // if ctrl-left click without movement and
+            // if note under cursor is selected, and ctrl is held
+            // and buttondown didn't just select one
+            if (!ths.m_justselected_one &&
+                ths.m_seq->select_note_events( current_tick, current_note,
+                                           current_tick, current_note,
+                                           sequence::e_is_selected ) &&
+                (a_ev->state & GDK_CONTROL_MASK))
+            {
+                // deselect the note
+                numsel = ths.m_seq->select_note_events( current_tick, current_note,
+                                                    current_tick, current_note,
+                                                    sequence::e_deselect );
+                needs_update = true;
+            }
+        }
+        ths.m_justselected_one = false; // clear flag on left button up
+
+        if (  ths.m_moving  ){
+
+            /* adjust for snap */
+            delta_x -= ths.m_move_snap_offset_x;
+
+            /* convert deltas into screen corridinates */
+            ths.convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
+
+            /* since delta_note was from delta_y, it will be filpped
+               ( delta_y[0] = note[127], etc.,so we have to adjust */
+            delta_note = delta_note - (c_num_keys-1);
+
+            ths.m_seq->push_undo();
+            ths.m_seq->move_selected_notes( delta_tick, delta_note );
+            needs_update = true;
+        }
+    }
+
+    // right click or leftctrl click button up for selection box
+    if ( a_ev->button == 3 || a_ev->button == 1 ){
+        if ( ths.m_selecting )
+        {
+            ths.xy_to_rect ( ths.m_drop_x,
+                    ths.m_drop_y,
+                    ths.m_current_x,
+                    ths.m_current_y,
+                    &x, &y,
+                    &w, &h );
+
+            ths.convert_xy( x,     y, &tick_s, &note_h );
+            ths.convert_xy( x+w, y+h, &tick_f, &note_l );
+
+            numsel = ths.m_seq->select_note_events( tick_s, note_h, tick_f, note_l, sequence::e_toggle_selection );
+
+            needs_update = true;
+        }
+    }
+    if ( a_ev->button == 3 )
+    {
+        m_erase_painting = false;
+    }
+
+    /* turn off */
+    ths.m_selecting = false;
+    ths.m_moving = false;
+    ths.m_growing = false;
+    ths.m_paste = false;
+    ths.m_moving_init = false;
+    ths.m_painting = false;
+
+    ths.m_seq->unpaint_all();
+
+    // context sensative mouse pointer...
+    updateMousePtr( ths );
+
+
+    /* if they clicked, something changed */
+    if (  needs_update ){
+
+        ////printf( "needs_update2\n" );
+
+        ths.m_seq->set_dirty();
+        //redraw_events();
+
+    }
+    return true;
+}
+
+bool FruitySeqRollInput::on_motion_notify_event(GdkEventMotion* a_ev, seqroll& ths)
+{
+    ths.m_current_x = (int) (a_ev->x  + ths.m_scroll_offset_x );
+    ths.m_current_y = (int) (a_ev->y  + ths.m_scroll_offset_y );
+
+    int note;
+    long tick;
+
+    if ( ths.m_moving_init ){
+        ths.m_moving_init = false;
+        ths.m_moving = true;
+    }
+
+    // context sensitive mouse pointer...
+    updateMousePtr( ths );
+
+    // ctrl-left click drag on selected note(s) starts a copy/unselect/paste
+    // don't begin the paste until mouse moves a few pixels, filter out the unsteady hand
+    if ( ths.m_is_drag_pasting_start &&
+         (6 <= abs(m_drag_paste_start_pos[0] - (long)a_ev->x) ||
+          6 <= abs(m_drag_paste_start_pos[1] - (long)a_ev->y))  )
+    {
+        ths.m_seq->copy_selected();
+        ths.m_seq->unselect();
+        ths.start_paste();
+
+        ths.m_is_drag_pasting_start = false;
+        ths.m_is_drag_pasting = true;
+    }
+
+
+
+    ths.snap_y( &ths.m_current_y );
+    ths.convert_xy( 0, ths.m_current_y, &tick, &note );
+
+    ths.m_seqkeys_wid->set_hint_key( note );
+
+    if ( ths.m_selecting || ths.m_moving || ths.m_growing || ths.m_paste ){
+
+        if ( ths.m_moving || ths.m_paste ){
+            ths.snap_x( &ths.m_current_x );
+        }
+
+        ths.draw_selection_on_window();
+        return true;
+
+    }
+
+    if ( ths.m_painting )
+    {
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_xy( ths.m_current_x, ths.m_current_y, &tick, &note );
+
+        ths.m_seq->add_note( tick, ths.m_note_length - 2, note, true );
+        return true;
+    }
+
+    if (m_erase_painting)
+    {
+        ths.convert_xy( ths.m_current_x, ths.m_current_y, &tick, &note );
+        if ( ths.m_seq->select_note_events( tick, note,
+                                            tick, note,
+                                            sequence::e_would_select) )
+        {
+            /* remove only the note under the cursor,
+               leave the selection intact */
+            ths.m_seq->push_undo();
+            ths.m_seq->select_note_events( tick, note,
+                                        tick, note,
+                                        sequence::e_remove_one );
+            ths.m_seq->set_dirty();
+        }
+    }
+    
+
+    return false;
+}
+
+
+
+
+
+/* popup menu calls this */
+void
+Seq24SeqRollInput::set_adding( bool a_adding, seqroll& ths )
+{
+    if ( a_adding ){
+
+	ths.get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
+	m_adding = true;
+
+    } else {
+
+	ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+	m_adding = false;
+    }
+}
+
+bool Seq24SeqRollInput::on_button_press_event(GdkEventButton* a_ev, seqroll& ths)
+{
+    int numsel;
+
+    long tick_s;
+    long tick_f;
+    int note_h;
+    int note_l;
+
+    int norm_x, norm_y, snapped_x, snapped_y;
+
+    ths.grab_focus(  );
+
+    bool needs_update = false;
+
+    snapped_x = norm_x = (int) (a_ev->x + ths.m_scroll_offset_x );
+    snapped_y = norm_y = (int) (a_ev->y + ths.m_scroll_offset_y );
+
+    ths.snap_x( &snapped_x );
+    ths.snap_y( &snapped_y );
+
+    /* y is always snapped */
+    ths.m_current_y = ths.m_drop_y = snapped_y;
+
+    /* reset box that holds dirty redraw spot */
+    ths.m_old.x = 0;
+    ths.m_old.y = 0;
+    ths.m_old.width = 0;
+    ths.m_old.height = 0;
+
+    if ( ths.m_paste ){
+
+        ths.convert_xy( snapped_x, snapped_y, &tick_s, &note_h );
+        ths.m_paste = false;
+        ths.m_seq->push_undo();
+        ths.m_seq->paste_selected( tick_s, note_h );
+
+        needs_update = true;
+
+    } else {
+
+        /*  left mouse button     */
+        if ( a_ev->button == 1 ||
+             a_ev->button == 2 )
+        {
+
+            /* selection, normal x */
+            ths.m_current_x = ths.m_drop_x = norm_x;
+
+            /* turn x,y in to tick/note */
+            ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &tick_s, &note_h );
+
+            if ( m_adding )
+            {
+                /* start the paint job */
+                ths.m_painting = true;
+
+                /* adding, snapped x */
+                ths.m_current_x = ths.m_drop_x = snapped_x;
+                ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &tick_s, &note_h );
+
+                // test if a note is already there
+                // fake select, if so, no add
+                if ( ! ths.m_seq->select_note_events( tick_s, note_h,
+                                                  tick_s, note_h,
+                                                  sequence::e_would_select ))
+                {
+
+                    /* add note, length = little less than snap */
+                    ths.m_seq->push_undo();
+                    ths.m_seq->add_note( tick_s, ths.m_note_length - 2, note_h, true );
+
+                    needs_update = true;
+                }
+
+            }
+            else /* selecting */
+            {
+
+
+                if ( !ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_is_selected ))
+                {
+                    if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_seq->unselect();
+                    }
+
+
+                    /* on direct click select only one event */
+                    numsel = ths.m_seq->select_note_events( tick_s,note_h,tick_s,note_h,
+                                                        sequence::e_select_one );
+
+                    /* none selected, start selection box */
+                    if ( numsel == 0 )
+                    {
+                        if ( a_ev->button == 1 )
+                            ths.m_selecting = true;
+                    }
+                    else
+                    {
+                        needs_update = true;
+                    }
+                }
+
+
+                if ( ths.m_seq->select_note_events( tick_s, note_h,
+                                                tick_s, note_h,
+                                                sequence::e_is_selected ))
+                {
+                    // moving - left click only
+                    if ( a_ev->button == 1 && !(a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_moving_init = true;
+                        needs_update = true;
+
+
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note_h,
+                                &tick_f, &note_l );
+
+
+                        ths.convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
+                                &ths.m_selected.x,
+                                &ths.m_selected.y,
+                                &ths.m_selected.width,
+                                &ths.m_selected.height );
+
+                        /* save offset that we get from the snap above */
+                        int adjusted_selected_x = ths.m_selected.x;
+                        ths.snap_x( &adjusted_selected_x );
+                        ths.m_move_snap_offset_x = ( ths.m_selected.x - adjusted_selected_x);
+
+                        /* align selection for drawing */
+                        ths.snap_x( &ths.m_selected.x );
+
+                        ths.m_current_x = ths.m_drop_x = snapped_x;
+                    }
+
+                    /* middle mouse button, or left-ctrl click (for 2button mice) */
+                    if ( a_ev->button == 2 ||
+                         (a_ev->button == 1 && (a_ev->state & GDK_CONTROL_MASK)) ){
+
+                        /* moving, normal x */
+                        //m_current_x = m_drop_x = norm_x;
+                        //convert_xy( m_drop_x, m_drop_y, &tick_s, &note_h );
+
+                        ths.m_growing = true;
+
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note_h,
+                                    &tick_f, &note_l );
+
+                        ths.convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
+                                &ths.m_selected.x,
+                                &ths.m_selected.y,
+                                &ths.m_selected.width,
+                                &ths.m_selected.height );
+
+                    }
+                }
+           }
+       }
+
+        /*     right mouse button      */
+        if ( a_ev->button == 3 ){
+            set_adding( true, ths );
+        }
+
+   }
+
+    /* if they clicked, something changed */
+    if ( needs_update ){
+
+        ////printf( "needs update\n" );
+        ths.m_seq->set_dirty();
+        //redraw_events();
+    }
+    return true;
+}
+
+bool Seq24SeqRollInput::on_button_release_event(GdkEventButton* a_ev, seqroll& ths)
+{
+    long tick_s;
+    long tick_f;
+    int note_h;
+    int note_l;
+    int x,y,w,h;
+    int numsel;
+
+    bool needs_update = false;
+
+    ths.m_current_x = (int) (a_ev->x + ths.m_scroll_offset_x );
+    ths.m_current_y = (int) (a_ev->y + ths.m_scroll_offset_y );
+
+    ths.snap_y ( &ths.m_current_y );
+
+    if ( ths.m_moving )
+        ths.snap_x( &ths.m_current_x );
+
+    int delta_x = ths.m_current_x - ths.m_drop_x;
+    int delta_y = ths.m_current_y - ths.m_drop_y;
+
+    long delta_tick;
+    int delta_note;
+
+    if ( a_ev->button == 1 ){
+
+        if ( ths.m_selecting ){
+
+            ths.xy_to_rect ( ths.m_drop_x,
+                    ths.m_drop_y,
+                    ths.m_current_x,
+                    ths.m_current_y,
+                    &x, &y,
+                    &w, &h );
+
+            ths.convert_xy( x,     y, &tick_s, &note_h );
+            ths.convert_xy( x+w, y+h, &tick_f, &note_l );
+
+            numsel = ths.m_seq->select_note_events( tick_s, note_h, tick_f, note_l, sequence::e_select );
+
+            needs_update = true;
+        }
+
+        if (  ths.m_moving  ){
+
+            /* adjust for snap */
+            delta_x -= ths.m_move_snap_offset_x;
+
+            /* convert deltas into screen corridinates */
+            ths.convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
+
+            /* since delta_note was from delta_y, it will be filpped
+               ( delta_y[0] = note[127], etc.,so we have to adjust */
+            delta_note = delta_note - (c_num_keys-1);
+
+            ths.m_seq->push_undo();
+            ths.m_seq->move_selected_notes( delta_tick, delta_note );
+            needs_update = true;
+        }
+
+   }
+
+    if ( a_ev->button == 2 || a_ev->button == 1 ){
+
+        if ( ths.m_growing ){
+
+            /* convert deltas into screen corridinates */
+            ths.convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
+            ths.m_seq->push_undo();
+
+            if ( a_ev->state & GDK_SHIFT_MASK )
+            {
+                ths.m_seq->stretch_selected( delta_tick );
+            }
+            else
+            {
+                ths.m_seq->grow_selected( delta_tick );
+            }
+
+            needs_update = true;
+        }
+    }
+
+    if ( a_ev->button == 3 ){
+        set_adding( false, ths );
+    }
+
+    /* turn off */
+    ths.m_selecting = false;
+    ths.m_moving = false;
+    ths.m_growing = false;
+    ths.m_paste = false;
+    ths.m_moving_init = false;
+    ths.m_painting = false;
+
+    ths.m_seq->unpaint_all();
+
+    /* if they clicked, something changed */
+    if (  needs_update ){
+
+        ////printf( "needs_update2\n" );
+
+        ths.m_seq->set_dirty();
+        //redraw_events();
+
+    }
+    return true;
+}
+
+bool Seq24SeqRollInput::on_motion_notify_event(GdkEventMotion* a_ev, seqroll& ths)
+{
+    ths.m_current_x = (int) (a_ev->x  + ths.m_scroll_offset_x );
+    ths.m_current_y = (int) (a_ev->y  + ths.m_scroll_offset_y );
+
+    int note;
+    long tick;
+
+    if ( ths.m_moving_init ){
+        ths.m_moving_init = false;
+        ths.m_moving = true;
+    }
+
+
+    ths.snap_y( &ths.m_current_y );
+    ths.convert_xy( 0, ths.m_current_y, &tick, &note );
+
+    ths.m_seqkeys_wid->set_hint_key( note );
+
+    if ( ths.m_selecting || ths.m_moving || ths.m_growing || ths.m_paste ){
+
+        if ( ths.m_moving || ths.m_paste ){
+            ths.snap_x( &ths.m_current_x );
+        }
+
+        ths.draw_selection_on_window();
+        return true;
+
+    }
+
+    if ( ths.m_painting )
+    {
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_xy( ths.m_current_x, ths.m_current_y, &tick, &note );
+
+        ths.m_seq->add_note( tick, ths.m_note_length - 2, note, true );
+        return true;
+    }
+
+    return false;
+}
